/*  Canon Bubble Jet Print Filter.
 *  Copyright CANON INC. 2001-2002
 *  All Rights Reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include	<gtk/gtk.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<string.h>
#include	<stdio.h>

#include	"support.h"
#include	"lmsmsock.h"
#include	"smstat.h"

char *SM_GetStatVal( char *,char *, char *);
char *SM_GetStatValC( char *,char *, char *);
int  SM_ComCreate( char *, char * );
void print_sts_read( GtkWidget * );
void print_err_check( GtkWidget *, char );
void DOC_InkOut_display(GtkWidget *, char * );
void DWS_InkLow_display(GtkWidget *, char * );
void ink_pixmap_display(GtkWidget *, short , short  );
void cartridge_pixmap_draw( GtkWidget * );
void cartridge_pixmap_clear( GtkWidget * );
void socket_send_LM( int );

extern	GdkPixmap	*pixmap;
extern	GdkPixmap	*g_out;
extern	GdkPixmap	*g_low;
extern	GdkBitmap	*mask_out;
extern	GdkBitmap	*mask_low;
extern	GdkPixmap	*g_out_bk;
extern	GdkPixmap	*g_low_bk;
extern	GdkBitmap	*mask_out_bk;
extern	GdkBitmap	*mask_low_bk;
extern	GdkPixmap	*g_I_24c1;
extern	GdkPixmap	*g_I_24c2;
extern	GdkPixmap	*g_I_24c3;
extern	GdkPixmap	*g_I_24b1;
extern	GdkPixmap	*g_I_24b2;
extern	GdkPixmap	*g_I_24b3;
extern	GdkPixmap	*g_low070;
extern	GdkPixmap	*g_low040;
extern	GdkPixmap	*g_low010;
extern	GdkBitmap	*mask_24b3;
extern	GdkBitmap	*mask_24c3;
extern	GdkBitmap	*mask_24b1;
extern	GdkBitmap	*mask_24c1;
extern	GdkBitmap	*mask_low010;
extern	GdkBitmap	*mask_low040;
extern	GdkBitmap	*mask_low070;
extern	lmsm_socket	lmsm_s;
extern	int		sock_path;
extern	int		enable_cancel;
extern	int		printing_stat;
extern	char		wait_end;
extern	char		fault_stat;
extern	int		dw,dh;
extern	char		flag_noparent;
extern	char		n_ptr_sub[256];	
extern	char		sm_gap;	
extern	short		model_id;
extern	short		chd_kind;
extern	short		dev_type;
extern	short		cil_kind;

extern  GdkPixmap	**ink_p[];
extern  GdkBitmap	**mask_p[];
extern  struct pat_t	pat_tbl[CHD_CNT2][CHD_AREA_MAX];
extern  struct pr_t	pr_tbl[MODEL_CNT];
#ifdef DEBUG
extern	void		write_log();
#endif

/*---------------------------------
 * Print Status Read
 ----------------------------------*/
void
print_sts_read(GtkWidget *window1)
{
	GtkWidget	*text1;
	GtkWidget	*label1;
	GtkWidget	*label2;
	GtkWidget	*print_cancel;
	GtkWidget	*drawingarea1;
	GdkRectangle	update_rect;

	int		r_size;
	char		*stat;
	char		sts_str[MAX_STATBUF];
	char		mes_str[MAX_STATBUF];

	union{
		int	sts_v;
		char	sts_vc[4];
	}sts;
	lmsm_socket	lmsm_s2;

#ifdef DEBUG
	write_log("Status READ   \n");
#endif

	r_size=read( sock_path, &lmsm_s, sizeof(lmsm_s));

	if( r_size == -1 ) return;
//	if( lmsm_s.prn_data.stat.stat_buffer[1] == 0 ) return ;
	if( lmsm_s.socket_type != LMtoSM ) return;

#ifdef DEBUG
	if( lmsm_s.prn_data.stat.printer_fault == 1 )
		write_log(" Fault ON \n");
	else if( lmsm_s.prn_data.stat.printer_fault == 0 )
		write_log(" Fault OFF\n");
	else if( lmsm_s.prn_data.stat.printer_fault == 2 )
		write_log(" Printer Offline\n");

	write_log(&(lmsm_s.prn_data.stat.stat_buffer[2]));
	write_log("\n");
#endif
	text1 = lookup_widget( window1, "text1" );
	label1 = lookup_widget( window1, "label1" );
	label2 = lookup_widget( window1, "label2" );
	print_cancel = lookup_widget( window1, "print_cancel" );

	// Device type Get
	dev_type = lmsm_s.device_type;

	// Offline Check	
	if( lmsm_s.prn_data.stat.printer_fault == 2 ){
#ifdef DEBUG
		write_log(" Printer Offline    \n");
#endif
		fault_stat = 2;	

		// Cartridge Area Clear
		cartridge_pixmap_clear( window1 );

		gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);
		gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				 _("Printer not responding.\n") , -1);
		gtk_label_set_text( GTK_LABEL(label1), _("Cartridge Type : "));
		if( sm_gap ) gtk_label_set_text( GTK_LABEL(label2), _("Paper thickness lever position : "));

		if( (printing_stat != 0) || ( wait_end == 1 ) ){
 			socket_send_LM( LM_PRN_CANCEL );
		}							
		update_rect.x = 0;
		update_rect.y = 0;
		update_rect.width = window1->allocation.width;
		update_rect.height = window1->allocation.height;
		drawingarea1 = lookup_widget( window1, "drawingarea1" );
		gtk_widget_draw( drawingarea1, &update_rect );
		return ;
	}else if( fault_stat == 2 ){
		lmsm_s2.prn_data.com.com_size = SM_ComCreate( lmsm_s2.prn_data.com.com_buffer,
								SM_INIT_BJF850 );
		lmsm_s2.socket_type = SMtoLM;	
		lmsm_s2.command     = LM_PRN_COM;
		write( sock_path, &lmsm_s2, sizeof(lmsm_s));
	
		socket_send_LM( LM_PRN_START );

		fault_stat = 0;
#ifdef DEBUG
		write_log(" Restart Printer write LM_PRN_COM INIT_BJF850    \n");
#endif
	}

	/*-------------
	// BST: Check
	-------------*/
	memset( sts_str, 0, MAX_STATBUF );
	stat = SM_GetStatVal(&(lmsm_s.prn_data.stat.stat_buffer[2]),"BST:",sts_str);
	if(stat == 0) return ;

	if( fault_stat == 2 )	/* For F360 Retry at Power ON */
		fault_stat = 0;

	gtk_text_freeze( GTK_TEXT(text1) );

	// Status Area Clear
	gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);

	// Status Message Display
	sts.sts_v = strtol( sts_str,NULL,16 );
	if( sts.sts_vc[0] & 0x80 ){
		gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				 _("Printing.\n") , -1);
		enable_cancel = 1;
		printing_stat = 2;
	}else{
		if( printing_stat != 0 )
			wait_end = 1;
		sts.sts_v = strtol( sts_str,NULL,16 );
		if( (wait_end == 1) && !(sts.sts_vc[0] & 0x28)){
			socket_send_LM( LM_PRN_END );
		}
		gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				 _("Printer is online.\n")  , -1);
		enable_cancel = 0;
		printing_stat = 0;
	}

	/*-------------
	// LVR: Check
	-------------*/
	memset( sts_str, 0, MAX_STATBUF );
	stat = SM_GetStatVal(&(lmsm_s.prn_data.stat.stat_buffer[2]),"LVR:",sts_str);
	sm_gap = 0;
	if( stat ){
		if( pr_tbl[model_id].lvr_pos == LVR_RL ){
			if( !(strcmp( sts_str, "GAL,W" )) )
				sprintf( mes_str, "%s%s",_("Paper thickness lever position : "), _("right") );
			else if( !(strcmp( sts_str, "GAL,N" )) )
				sprintf( mes_str, "%s%s",_("Paper thickness lever position : "), _("left") );
		}else{
			if( !(strcmp( sts_str, "GAL,W" )) )
				sprintf( mes_str, "%s%s",_("Paper thickness lever position : "), _("down") );
			else if( !(strcmp( sts_str, "GAL,N" )) )
				sprintf( mes_str, "%s%s",_("Paper thickness lever position : "), _("up") );
		}
		gtk_label_set_text( GTK_LABEL(label2), mes_str);
		sm_gap = 1;
	}else
		gtk_label_set_text( GTK_LABEL(label2), "");

	/*-------------
	// CIL: Check
	-------------*/
	memset( sts_str, 0, MAX_STATBUF );
	stat = SM_GetStatVal(&(lmsm_s.prn_data.stat.stat_buffer[2]),"CIL:",sts_str);
	if( stat ){
		if( !(strncmp( sts_str, CIL_ON,2 )) )		// ink fill check ON ?
			cil_kind = 1;
		else
			cil_kind = 0;
	}
	/*-------------
	// CHD: Check
	-------------*/
	memset( sts_str, 0, MAX_STATBUF );
	stat = SM_GetStatVal(&(lmsm_s.prn_data.stat.stat_buffer[2]),"CHD:",sts_str);
	if( stat ){
		chd_kind = 0;	

		// Cartridge Area Clear
		cartridge_pixmap_clear( window1 );

#ifdef DEBUG
		write_log(" CHD Check      \n");
#endif
		// CHD_PHOTO_BJ for F850 seriese
		if( !(strncmp( sts_str, CHD_PHOTO_BJ,2 )) ||		// LS
		    !(strncmp( sts_str+3, CHD_PHOTO_BJ,2 )) ){		// For F900
			sprintf( mes_str, "%s%s",_("Cartridge Type : "), _("Photo") );
			gtk_label_set_text( GTK_LABEL(label1), mes_str );

			chd_kind = CHD_BC_50;
		}
		// CHD_COLOR_BJ for F360 & S600
		else if( !(strncmp( sts_str, CHD_COLOR_VC,2 )) ||	// VC
			 !(strncmp( sts_str, CHD_COLOR_CL,2 )) ){	// CL
				sprintf( mes_str, "%s%s",_("Cartridge Type : "), _("Color") );
				gtk_label_set_text( GTK_LABEL(label1), mes_str );

				if( model_id == MODEL_S300 ) {
					if( cil_kind != 1 )
						chd_kind = CHD_BC_24N;
					else
						chd_kind = CHD_BC_24;
				}else{
					chd_kind = CHD_BC_33;
				}
		}
		// CHD_PHOTOS_BJ for F360 or F660
		else if( !(strncmp( sts_str, CHD_PHOTO_VL,2 )) ){	// VL

			if( strstr( sts_str+3, CHD_COLOR_VC ) ){	// For F660
				chd_kind = CHD_BC_3231;
				sprintf( mes_str, "%s%s",_("Cartridge Type : "), _("Photo/Color") );
			}else{
				chd_kind = CHD_BC_34;
				sprintf( mes_str, "%s%s",_("Cartridge Type : "), _("Photo") );
			}
			gtk_label_set_text( GTK_LABEL(label1), mes_str );
		}
		// CHD_BLACK_BJ for F360
		else if( !(strncmp( sts_str, CHD_BLACK_BK,2 )) ){

			if( strstr( sts_str+3, CHD_COLOR_VC ) ){ 	// For F660
				chd_kind = CHD_BC_3031;
				sprintf( mes_str, "%s%s",_("Cartridge Type : "), _("Black/Color") );
			}else{
				chd_kind = CHD_BC_30;
				sprintf( mes_str, "%s%s",_("Cartridge Type : "), _("Black") );
			}
			gtk_label_set_text( GTK_LABEL(label1), mes_str );
		}
		else if( !(strncmp( sts_str, CHD_SCANNER,2 )) ){
			gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);
			gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				 	_("Scanner Cartridge detected.\nYou cannot print with this cartridge.\n"
					"Change to appropriate BJ cartridge.\n") , -1);	

			if( strstr( sts_str, CHD_COLOR_VC ) ){ 	// For F660
				chd_kind = CHD_BC_SC31;
				sprintf( mes_str,"%s%s",_("Cartridge Type : "), _("Scanner/Color")  );
			}else{
				chd_kind = CHD_BC_SC;
				sprintf( mes_str,"%s%s",_("Cartridge Type : "), _("Scanner")  );
			}
			gtk_label_set_text( GTK_LABEL(label1), mes_str );
		}
		else if( !(strncmp( sts_str, CHD_UNSUPORT,2 )) ){		
			sprintf( mes_str,"%s%s",_("Cartridge Type : "), _("Unsupported")  );
			gtk_label_set_text( GTK_LABEL(label1), mes_str );

			gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);	
			gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
			 	_("Unsupported cartridge installed.\nChange to appropriate BJ cartridge.\n"
				) , -1);	// 00.12.22	
		}
		else{ 
			sprintf( mes_str,"%s%s",_("Cartridge Type : "), _("Unknown")  );
			gtk_label_set_text( GTK_LABEL(label1), mes_str );

			gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);	
			sprintf( mes_str, 
				_("Cartridge not installed!\n"
				"Install %s in the printer.\n"),
				_("appropriate BJ cartridge"));		// 00.12.22
			gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,mes_str, -1);
		}

		// Drawing Area Pixmap draw
		cartridge_pixmap_draw( window1 );
	}

	/*-----------------------------------
	// Operator Call & other Error Check
	------------------------------------*/
	print_err_check( window1, sts.sts_vc[0] );

	if( model_id == MODEL_S300 && cil_kind != 1 ) {
		gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
		 	_("\nThe printer is set not to display a low ink warning.\n"),-1);
	}

	// Printer Status String Display
	gtk_text_thaw( GTK_TEXT(text1));

	// Cartridge Pixmap Display
	update_rect.x = 0;
	update_rect.y = 0;
	update_rect.width = window1->allocation.width;
	update_rect.height = window1->allocation.height;
	drawingarea1 = lookup_widget( window1, "drawingarea1" );
	gtk_widget_draw( drawingarea1, &update_rect );

	// Button Sensitive  
  	if( enable_cancel == 1 && dev_type != DEVICE_TYPE_USB )
  		gtk_widget_set_sensitive (print_cancel, TRUE );
	else
  		gtk_widget_set_sensitive (print_cancel, FALSE);

	// "Continue" Socket send to LanguageMonitor 
	if( printing_stat == 2 && fault_stat == 0 ){
		socket_send_LM( LM_PRN_CONT );
	}
	return ;
}



/*-----------------------------------
 * Operator Call & other Error Check
 -----------------------------------*/
void
print_err_check( GtkWidget *window1, char bst )
{
	GtkWidget	*text1;
	GtkWidget	*print_continue;
//	GtkWidget	*drawingarea1;
	GdkRectangle	update_rect;
	char 		sts_str[MAX_STATBUF];
	char 		mes_str[MAX_STATBUF];
	char		val_str[MAX_STATBUF];
	char 		*stat;
	char		*n_ptr;
	int		ink_warning;	
	int		ink_warning2;	
	int		dbs_tp = 0;
	int		i;
	struct	 	{
		int	val;
		char	*dws_no070;
		char	*dws_no040;
	} inkf_t[6] ={
			{0,DWS_INKLOW070_BLACK,	 DWS_INKLOW040_BLACK},
			{0,DWS_INKLOW070_PHOTO_C,DWS_INKLOW040_PHOTO_C},
			{0,DWS_INKLOW070_PHOTO_M,DWS_INKLOW040_PHOTO_M},
			{0,DWS_INKLOW070_CYAN,   DWS_INKLOW040_CYAN},
			{0,DWS_INKLOW070_MAGENTA,DWS_INKLOW040_MAGENTA},
			{0,DWS_INKLOW070_YELLOW, DWS_INKLOW040_YELLOW},
			};

	memset( n_ptr_sub, 0, 256 );	

	text1 = lookup_widget( window1, "text1" );
	update_rect.x = 0;
	update_rect.y = 0;
	update_rect.width = window1->allocation.width;
	update_rect.height = window1->allocation.height;

	/*---------------------
	 * Service Call
	 ----------------------*/
	// DSC: Check
	memset( sts_str, 0, MAX_STATBUF );
	stat = SM_GetStatVal(&(lmsm_s.prn_data.stat.stat_buffer[2]),"DSC:",sts_str);

	if( stat !=0 && (strcmp(sts_str,STS_NO)) && (strcmp(sts_str,STS_UNKOWN)) )
	{
		gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);
		if( !(strcmp( sts_str, DSC_USEDTANK_FULL )))
			gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				_("The used ink tank is full.\n"
				"Cancel printing and turn the printer off and then back on.\n"
				"If this doesn't clear the error, see the printer manual for more details."), -1);
		else {
			sprintf( mes_str, 
				_("Service error %s.\n"
				"Cancel printing and turn the printer off and then back on.\n"
				"If this doesn't clear the error, see the printer manual for details."), sts_str );
			gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
					 mes_str , -1);
		}
		enable_cancel = 1;	

		socket_send_LM( LM_PRN_STOP );

		return ;
	}

	/*----------------- 
	 * Printer Busy Detail
	 ------------------*/
	memset( sts_str, 0, MAX_STATBUF );
	stat = SM_GetStatVal(&(lmsm_s.prn_data.stat.stat_buffer[2]),"DBS:",sts_str);

	if( stat != 0 ){
		if( !(strcmp( sts_str, DBS_CLEANING ))){
			gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);
			gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				_("Cleaning.\nPlease wait.\n"), -1);
			enable_cancel = 0;
		}
		else if( !(strcmp( sts_str, DBS_CARTRIDGE_CHANGE ))){
			gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);
			gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				_("Cartridge replacement is in progress.\n"
				"Close the front cover after replacement is completed.\n"),-1);
			enable_cancel = 0;	
		}
		else if( !(strcmp( sts_str, DBS_TEST_PRINT ))){
			gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);
			gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				 _("Printing.\n") , -1);
			if( flag_noparent ) printing_stat = 1;	

			enable_cancel = 0;	
			dbs_tp = 1;
		}
		else if( !(strcmp( sts_str, DBS_PRINTER_USED ))){
			gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);
			gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				 _("Printer is in use via another interface.\nPlease wait.\n") , -1);
			enable_cancel = 0;	
		}
		else if( !(strcmp( sts_str, DBS_ENDING ))){
//			socket_send_LM( LM_PRN_CANCEL );
		}
		if( (strcmp( sts_str, STS_NO)) && (strcmp( sts_str, STS_UNKOWN ))){
			gtk_widget_show( window1 );
		}
	}

	/*--------------------
	 * Operator Call
	 ---------------------*/
	// DOC: Check
	memset( sts_str, 0, MAX_STATBUF );
	stat = SM_GetStatVal(&(lmsm_s.prn_data.stat.stat_buffer[2]),"DOC:",sts_str);

	if( stat != 0 ){
		if( (n_ptr = (char *)index( sts_str, ',' )) == NULL ) return;
		n_ptr++;
		if( (n_ptr = (char *)index( n_ptr  , ',' )) == NULL ) return;
		n_ptr++;

	   	if((strncmp( n_ptr, STS_NO, 2 )) && (strncmp(n_ptr,STS_UNKOWN,2)) ){

			fault_stat = 1;
#ifdef DEBUG
			write_log(" Operator Call !! fault_stat = 1 set      \n");
#endif
			print_continue = lookup_widget( window1, "print_continue" );
  			gtk_widget_set_sensitive (print_continue, FALSE);

			gtk_editable_delete_text( GTK_EDITABLE(text1), 0,-1);

		   	if( !(strncmp( n_ptr, DOC_PAPER_OUT, 4 ))){
				gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
					_("Paper out.\n"
					"Load paper and press printer's RESUME button.\n"), -1);
				enable_cancel = 0;
			}
			else if( !(strncmp( n_ptr, DOC_PAPER_JAM, 4 ))){
				gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
					_("Paper jammed.\n"
					"Remove jammed paper and press printer's RESUME button.\n"), -1);
				enable_cancel = 0;
			}
			else if( !(strncmp( n_ptr, DOC_CARTRIDGE_NOTHING, 4 ))
				|| !(strncmp( n_ptr, DOC_CARTRIDGE_NOTHING2, 4 ))){	// for F360 Only
				if( printing_stat != 0 
  				  && dev_type != DEVICE_TYPE_USB ){
					enable_cancel = 1;
					sprintf( mes_str, 
						_("Cartridge not installed!\n"
						"Install %s in the printer.\n"
						"or\nClick Cancel Printing if no cartridge available.\n"),
						_("appropriate BJ cartridge"));		// 00.12.22
				}else{
					enable_cancel = 0;	
					sprintf( mes_str, 
						_("Cartridge not installed!\n"
						"Install %s in the printer.\n"),
						_("appropriate BJ cartridge"));		// 00.12.22
				}
				gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,mes_str, -1);
			}
			else if( !(strncmp(n_ptr,"1402",4)) || !(strncmp(n_ptr,"1403",4)) || !(strncmp(n_ptr,"1405",4)) ){
				gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
					_("Operator error.\nPress printer RESUME button.\n"
					"If this doesn't clear the error, cancel printing and turn the printer off and then back on.\n"), -1);
				if( printing_stat != 0 ) enable_cancel = 1;
				else	enable_cancel = 0;	
			}

			else if( !(strncmp( n_ptr, DOC_SCANNER_DETECT, 4 ))){
				if( dbs_tp == 0 
  				  && dev_type != DEVICE_TYPE_USB ){
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
					_("Scanner cartridge detected!\nChange to appropriate cartridge.\n"
					"Click Cancel Printing to cancel operation.\n"), -1);
					enable_cancel = 1;
				}else{
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				 	_("Scanner Cartridge detected.\nYou cannot print with this cartridge.\n"
					"Change to appropriate BJ cartridge.\n") , -1);	
					enable_cancel = 0;	
				}
			}

			else if( !(strncmp( n_ptr, DOC_UNSUPORTED_CHD, 4 ))){	
				gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
				 	_("Unsupported cartridge installed.\nChange to appropriate BJ cartridge.\n"	
					) , -1);	// 00.12.22	
				enable_cancel = 0;
			}

		   	else if( !(strncmp( n_ptr, DOC_USEDTANK_ALMOST, 4 ))){
				gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
					_("The used ink tank is almost full.\n"
					"Press the printer's RESUME button to restart printing\n"), -1);
				if( printing_stat != 0 ) enable_cancel = 1;
				else	enable_cancel = 0;	
			}

		   	else if( !(strncmp( n_ptr, DOC_PROTECTOR, 4 ))){
				gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
					_("Protector not installed.\nInstall a protector properly in the printer.\n"),-1);
				if( printing_stat != 0 ) enable_cancel = 1;
				enable_cancel = 0;	
			}


			else if( strstr( n_ptr, DOC_INKOUT_PRE )
				|| strstr( n_ptr, DOC_COVER_OPEN )){

				if( strstr( n_ptr, DOC_INKOUT_PRE ) ){
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
						_("Ink has run out.\n"
						"Replace ink tank and close the front cover.\n"), -1);
					if( printing_stat != 0 ) enable_cancel = 1;	
					else	enable_cancel = 0;	
				}else{
					if( printing_stat != 0 ){	
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("Front cover is open.\n"
							"Unable to print until the front cover is closed.\n"), -1);
						enable_cancel = 1;
					}else{
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("Cartridge replacement is in progress.\n"
							"Close the front cover after replacement is completed.\n"), -1);
						enable_cancel = 0;
					}
				}

				if( strstr( n_ptr, DOC_INKOUT_BLACK )  ){
					if( chd_kind == CHD_BC_34 || chd_kind == CHD_BC_3231 )
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Photo Black\n"), -1);
					else
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Black\n"), -1);
					strcat( n_ptr_sub, DOC_INKOUT_BLACK",");	
				}

				if( strstr( n_ptr, DOC_INKOUT_PHOTO_C )  ){
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Photo Cyan\n"), -1);
					strcat( n_ptr_sub, DOC_INKOUT_PHOTO_C",");
				}

				if( strstr( n_ptr, DOC_INKOUT_PHOTO_M )  ){
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Photo Magenta\n"), -1);
					strcat( n_ptr_sub, DOC_INKOUT_PHOTO_M",");
				}

				if( strstr( n_ptr, DOC_INKOUT_CYAN )  ){
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Cyan\n"), -1);
					strcat( n_ptr_sub, DOC_INKOUT_CYAN",");	
				}

				if( strstr( n_ptr, DOC_INKOUT_MAGENTA )  ){
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Magenta\n"), -1);
					strcat( n_ptr_sub, DOC_INKOUT_MAGENTA",");
				}

				if( strstr( n_ptr, DOC_INKOUT_YELLOW )  ){
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Yellow\n") , -1);
					strcat( n_ptr_sub, DOC_INKOUT_YELLOW",");
				}

				DOC_InkOut_display( window1, n_ptr_sub );	
		   	}//"16"

			else {		
				gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
					_("Operator error.\nThe connected printer cannot work correctly.\n")
					 , -1);		
				if( printing_stat != 0 ) enable_cancel = 1;	
				else	enable_cancel = 0;	
			}	

			socket_send_LM( LM_PRN_STOP );

		}else{
			if( fault_stat == 1 ){
				fault_stat = 0;
				print_continue = lookup_widget( window1, "print_continue" );
  				gtk_widget_set_sensitive (print_continue, FALSE);
#ifdef DEBUG
		write_log(" fault_stat = 0 clear    \n");
#endif
			}
		}
	}

	/*-------------------
	 * CIR ( Ink Fill Detail)
	 -----------------------*/
	// CIR: Check
	memset( sts_str, 0, MAX_STATBUF );
	stat = SM_GetStatVal(&(lmsm_s.prn_data.stat.stat_buffer[2]),"CIR:",sts_str);

	if( (stat != NULL)  && ((model_id == MODEL_F900)||(model_id==MODEL_F9000)) ){
		memset( val_str, 0, MAX_STATBUF );

		for( i=0; i<6; i++ ){
			stat = SM_GetStatValC( stat,"=",val_str);
			inkf_t[i].val =  atoi( val_str );
			if( inkf_t[i].val == 70 )	strcat( n_ptr_sub, inkf_t[i].dws_no070 );
			if( inkf_t[i].val == 40 )	strcat( n_ptr_sub, inkf_t[i].dws_no040 );
		}

		if( inkf_t[0].val+inkf_t[1].val+inkf_t[2].val+inkf_t[3].val+inkf_t[4].val+inkf_t[5].val ){

			DWS_InkLow_display( window1, n_ptr_sub );
		}
	}

	/*------------------
	 * Warning
	 -------------------*/
	// DWS: Check
	ink_warning = ink_warning2 = 0;
	memset( sts_str, 0, MAX_STATBUF );
	stat = SM_GetStatVal(&(lmsm_s.prn_data.stat.stat_buffer[2]),"DWS:",sts_str);
	memset( mes_str, 0, MAX_STATBUF );	
	stat = SM_GetStatVal(&(lmsm_s.prn_data.stat.stat_buffer[2]),"DOC:",mes_str);	

	if( stat != 0 && (strncmp( sts_str, STS_NO, 2 ))&& (strncmp(sts_str,STS_UNKOWN,2)) ){
		if( !(strncmp( sts_str, DWS_INKLOW_PRE, 2 ))){

			if( (strstr( sts_str, DWS_INKLOW_24COLOR2 ))){		// S300
					if( ink_warning == 0 ){	
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("\nThe following ink tanks are running low.\n"), -1);
						ink_warning = 1;		
					}									
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Color\n"), -1);
					strcat( n_ptr_sub, DWS_INKLOW_24COLOR2",");
			}
			if( (strstr( sts_str, DWS_INKLOW_BLACK ))){
				if(!(strstr( mes_str, DOC_INKOUT_BLACK))){
					if( ink_warning == 0 ){	
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("\nThe following ink tanks are running low.\n"), -1);
						ink_warning = 1;		
					}									
					if( chd_kind == CHD_BC_34 || chd_kind == CHD_BC_3231 )
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Photo Black\n"), -1);
					else
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Black\n"), -1);
					strcat( n_ptr_sub, DWS_INKLOW_BLACK",");
				}	
			}
			if( (strstr( sts_str, DWS_INKLOW_PHOTO_C ))){
				if(!(strstr( mes_str, DOC_INKOUT_PHOTO_C))){	
					if( ink_warning == 0 ){	
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("\nThe following ink tanks are running low.\n"), -1);
						ink_warning = 1;		
					}									
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Photo Cyan\n"), -1);
					strcat( n_ptr_sub, DWS_INKLOW_PHOTO_C",");
				}		
			}
			if( (strstr( sts_str, DWS_INKLOW_PHOTO_M ))){
				if(!(strstr( mes_str, DOC_INKOUT_PHOTO_M))){	
					if( ink_warning == 0 ){	
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("\nThe following ink tanks are running low.\n"), -1);
						ink_warning = 1;		
					}									
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Photo Magenta\n") , -1);
					strcat( n_ptr_sub, DWS_INKLOW_PHOTO_M",");	
				}		
			}
			if( (strstr( sts_str, DWS_INKLOW_CYAN ))){
				if(!(strstr( mes_str, DOC_INKOUT_CYAN))){
					if( ink_warning == 0 ){	
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("\nThe following ink tanks are running low.\n"), -1);
						ink_warning = 1;		
					}									
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Cyan\n"), -1);
					strcat( n_ptr_sub, DWS_INKLOW_CYAN",");	
				}	
			}
			if( (strstr( sts_str, DWS_INKLOW_MAGENTA ))){
				if(!(strstr( mes_str, DOC_INKOUT_MAGENTA))){	
					if( ink_warning == 0 ){	
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("\nThe following ink tanks are running low.\n"), -1);
						ink_warning = 1;		
					}									
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Magenta\n"), -1);
					strcat( n_ptr_sub, DWS_INKLOW_MAGENTA",");
				}	
			}
			if( (strstr( sts_str, DWS_INKLOW_YELLOW ))){
				if(!(strstr( mes_str, DOC_INKOUT_YELLOW))){	
					if( ink_warning == 0 ){	
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("\nThe following ink tanks are running low.\n"), -1);
						ink_warning = 1;		
					}									
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Yellow\n") , -1);
					strcat( n_ptr_sub, DWS_INKLOW_YELLOW",");
				}	
			}
			if( (strstr( sts_str, DWS_INKLOW_24COLOR3 ))){		// S300
					if( ink_warning != 3 ){	
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("\nThe remaining level of the following ink is unknown:\n"), -1);
						ink_warning = 3;		
					}									
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Color\n"), -1);
					strcat( n_ptr_sub, DWS_INKLOW_24COLOR3",");
			}
			if( (strstr( sts_str, DWS_INKLOW_24BLACK3 ))){		// S300
					if( ink_warning != 3 ){	
						gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
							_("\nThe remaining level of the following ink is unknown:\n"), -1);
						ink_warning = 3;		
					}									
					gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,_(" Black\n"), -1);
					strcat( n_ptr_sub, DWS_INKLOW_24BLACK3",");
			}
			if( ink_warning == 3 ){
				gtk_text_insert( GTK_TEXT(text1),NULL,NULL,NULL,
					_("\nThere is a possibility that the printer cannot detect the remaininig ink level properly."
					" Reset the ink counter using the Maintenance tab of the printer driver properties"
					" whenever you have replaced any ink tank with new one.\n"), -1);
			}
			if( (strstr( sts_str, DWS_INKLOW_24COLOR1 )))		// S300
				strcat( n_ptr_sub, DWS_INKLOW_24COLOR1",");	//  for Bitmap  
			if( (strstr( sts_str, DWS_INKLOW_24BLACK1 )))		// S300
				strcat( n_ptr_sub, DWS_INKLOW_24BLACK1",");	//  for Bitmap

			DWS_InkLow_display( window1, n_ptr_sub );
		}
	}
}

/*
 * Command Create
 *  Return: Length of Command Total
 */
int SM_ComCreate( char *com_str, char *com) 
{
	struct{
		char	esc[4];
		short	tot_l;
		char	init[2];
		char 	cm_len[2];
		char	cm_str[MAX_COMBUF];
	}tmp_com2;
	union{
		short	com_s;
		char	com_c[2];
	}cml;
	
	memset( (char *)&tmp_com2, 0, MAX_COMBUF+9);
	cml.com_s = strlen( com ) +2 ;

	strcpy( &(tmp_com2.esc[1]), "\x1b[K");
	tmp_com2.tot_l = cml.com_s + 2;

	strcpy( &(tmp_com2.init[1]),"\x1e");
	tmp_com2.cm_len[0] = cml.com_c[1];
	tmp_com2.cm_len[1] = cml.com_c[0];
	strcpy( (char *)&(tmp_com2.cm_str), com);

	memcpy( com_str, (char *)&(tmp_com2.esc[1]), cml.com_s+9);

	return (cml.com_s+9);
}

/*
 * Get Value from Status String
 *  Return: Pointer to Value
 *	    or NULL 
 */
char
*SM_GetStatVal(	char	*sts_ptr,	
		char	*get_str,
		char	*sts_str)
{
	char *s_ptr,*t_ptr;
	int   s_len;

	if( (s_ptr = (char *)strstr( sts_ptr, get_str )) == NULL)
		return NULL; 

	s_ptr += 4;
	if( (t_ptr = (char *)index( s_ptr,';' )) == NULL ){
		strcpy( sts_str, s_ptr );
		return s_ptr;
	}
	s_len = t_ptr-s_ptr;
	memcpy( sts_str, s_ptr, s_len );
	
	return s_ptr;
}

/*
 * Get Value from Status String with ','
 *  Return: Pointer to Value
 *	    or NULL 
 */
char
*SM_GetStatValC(	char	*sts_ptr,	
		char	*get_str,
		char	*sts_str)
{
	char *s_ptr,*t_ptr;
	int   s_len;

	if( (s_ptr = (char *)strstr( sts_ptr, get_str )) == NULL)
		return NULL; 

	s_ptr += 1;
	if( (t_ptr = (char *)index( s_ptr,',' )) == NULL ){
		strcpy( sts_str, s_ptr );
		return s_ptr;
	}
	s_len = t_ptr-s_ptr;
	memcpy( sts_str, s_ptr, s_len );
	
	return s_ptr;
}

/*
 * Display Ink-Out pixmaps
 *
 */
void DOC_InkOut_display( GtkWidget *window1, char *s_str )
{
	if( (strstr( s_str, DOC_INKOUT_BLACK ))){
		if( chd_kind == CHD_BC_30 || chd_kind == CHD_BC_33 || 
			chd_kind == CHD_BC_3031 )
			ink_pixmap_display( window1, I_bb, INK_OUT );
		else if( chd_kind == CHD_BC_34 || chd_kind == CHD_BC_3231 )
			ink_pixmap_display( window1, I_pb, INK_OUT );
		else 
			ink_pixmap_display( window1, I_bk, INK_OUT );
	}

	if( (strstr( s_str, DOC_INKOUT_YELLOW )))
		ink_pixmap_display( window1, I_ye, INK_OUT );

	if( (strstr( s_str, DOC_INKOUT_MAGENTA )))
		ink_pixmap_display( window1, I_ma, INK_OUT );

	if( (strstr( s_str, DOC_INKOUT_CYAN )))
		ink_pixmap_display( window1, I_cy, INK_OUT );

	if( (strstr( s_str, DOC_INKOUT_PHOTO_M )))
		ink_pixmap_display( window1, I_pm, INK_OUT );

	if( (strstr( s_str, DOC_INKOUT_PHOTO_C )))
		ink_pixmap_display( window1, I_pc, INK_OUT );
}
/*
 * Display Ink-Low pixmaps
 *
 */
void DWS_InkLow_display( GtkWidget *window1, char *s_str )
{

	if( (strstr( s_str, DWS_INKLOW_BLACK ))){
		if( chd_kind == CHD_BC_30 || chd_kind == CHD_BC_33 || 
			chd_kind == CHD_BC_3031 )
			ink_pixmap_display( window1, I_bb, INK_LOW );
		else if( chd_kind == CHD_BC_34 || chd_kind == CHD_BC_3231 )
			ink_pixmap_display( window1, I_pb, INK_LOW );
		else if( chd_kind == CHD_BC_24 )
			ink_pixmap_display( window1, I_24bf, INK_LOW );
		else
			ink_pixmap_display( window1, I_bk, INK_LOW );
	}

	if( (strstr( s_str, DWS_INKLOW_YELLOW )))
		ink_pixmap_display( window1, I_ye, INK_LOW );

	if( (strstr( s_str, DWS_INKLOW_MAGENTA )))
		ink_pixmap_display( window1, I_ma, INK_LOW );

	if( (strstr( s_str, DWS_INKLOW_CYAN )))
		ink_pixmap_display( window1, I_cy, INK_LOW );

	if( (strstr( s_str, DWS_INKLOW_PHOTO_M )))
		ink_pixmap_display( window1, I_pm, INK_LOW );

	if( (strstr( s_str, DWS_INKLOW_PHOTO_C )))
		ink_pixmap_display( window1, I_pc, INK_LOW );

	if( (strstr( s_str, DWS_INKLOW_24BLACK1 )))		// S300
		ink_pixmap_display( window1, I_24bf, INK_LOW1 );

	if( (strstr( s_str, DWS_INKLOW_24BLACK3 )))		// S300
		ink_pixmap_display( window1, I_24bf, INK_OUT );

	if( (strstr( s_str, DWS_INKLOW_24COLOR1 )))		// S300
		ink_pixmap_display( window1, I_24cf, INK_LOW1 );

	if( (strstr( s_str, DWS_INKLOW_24COLOR2 )))		// S300
		ink_pixmap_display( window1, I_24cf, INK_LOW );

	if( (strstr( s_str, DWS_INKLOW_24COLOR3 )))		// S300
		ink_pixmap_display( window1, I_24cf, INK_OUT );


	if( (strstr( s_str, DWS_INKLOW070_BLACK  )))
		ink_pixmap_display( window1, I_bk, INK_LOW070 );

	if( (strstr( s_str, DWS_INKLOW070_YELLOW )))
		ink_pixmap_display( window1, I_ye, INK_LOW070 );

	if( (strstr( s_str, DWS_INKLOW070_PHOTO_C )))
		ink_pixmap_display( window1, I_pc, INK_LOW070 );

	if( (strstr( s_str, DWS_INKLOW070_MAGENTA )))
		ink_pixmap_display( window1, I_ma, INK_LOW070 );

	if( (strstr( s_str, DWS_INKLOW070_CYAN )))
		ink_pixmap_display( window1, I_cy, INK_LOW070 );

	if( (strstr( s_str, DWS_INKLOW070_PHOTO_M )))
		ink_pixmap_display( window1, I_pm, INK_LOW070 );

	if( (strstr( s_str, DWS_INKLOW040_BLACK  )))
		ink_pixmap_display( window1, I_bk, INK_LOW040 );

	if( (strstr( s_str, DWS_INKLOW040_YELLOW )))
		ink_pixmap_display( window1, I_ye, INK_LOW040 );

	if( (strstr( s_str, DWS_INKLOW040_PHOTO_C )))
		ink_pixmap_display( window1, I_pc, INK_LOW040 );

	if( (strstr( s_str, DWS_INKLOW040_MAGENTA )))
		ink_pixmap_display( window1, I_ma, INK_LOW040 );

	if( (strstr( s_str, DWS_INKLOW040_CYAN )))
		ink_pixmap_display( window1, I_cy, INK_LOW040 );

	if( (strstr( s_str, DWS_INKLOW040_PHOTO_M )))
		ink_pixmap_display( window1, I_pm, INK_LOW040 );
}
/*
 * 
 *
 */
void ink_pixmap_display(GtkWidget *window1,
			short	pat_n,
			short	flag)
{
	int		i;
	int		disp_x;
	GdkPixmap 	**pix;
	GdkBitmap 	**pix_m;

	for( i=0; i<CHD_CNT2; i++ ){
		if( pat_tbl[chd_kind-1][i].pat_no == pat_n ) 	break;
		if( pat_tbl[chd_kind-1][i+1].pat_no == 0 )	return;
	}
	disp_x = (pat_tbl[chd_kind-1][i].p_x);

	if( pat_n == I_bb ){
		if( flag == INK_OUT ){	
					pix = &g_out_bk;
					pix_m = &mask_out_bk;
		}else{
					pix_m = &mask_low_bk;
					pix = &g_low_bk;
		}
	}else if( pat_n == I_24bf ){			// S300
		pix_m = &mask_24b3;
		if( flag == INK_OUT )		pix = &g_I_24b3;
		else if( flag == INK_LOW1 ){ 	
						pix = &g_I_24b1;
						pix_m = &mask_24b1;
		}else 				pix = &g_I_24b2;
	}else if( pat_n == I_24cf ){			// S300
		pix_m = &mask_24c3;
		if( flag == INK_OUT )		pix = &g_I_24c3;
		else if( flag == INK_LOW1 ){ 	
						pix = &g_I_24c1;
						pix_m = &mask_24c1;
		}else 				pix = &g_I_24c2;
	}else{
		switch( flag ){
		 case INK_OUT:	
					pix = &g_out;
					pix_m = &mask_out;
					break;
		 case INK_LOW070:
					pix = &g_low070;
					pix_m = &mask_low070;
					break;
		 case INK_LOW040:
					pix = &g_low040;
					pix_m = &mask_low040;
					break;
		 default:
				if( model_id == MODEL_F900 || model_id == MODEL_F9000 ){
					pix = &g_low010;
					pix_m = &mask_low010;
					break;
				}else{
					pix = &g_low;
					pix_m = &mask_low;
					break;
				}
		}
	}
	/* Low/Out pixmap display */
	gdk_gc_set_clip_mask( window1->style->bg_gc[GTK_WIDGET_STATE(window1)], *pix_m);
	gdk_gc_set_clip_origin( window1->style->bg_gc[GTK_WIDGET_STATE(window1)], 
		dw+disp_x, dh );

	gdk_draw_pixmap( pixmap,
		window1->style->bg_gc[GTK_WIDGET_STATE(window1)],
		*pix,0,0,
		dw+disp_x, dh,
		window1->allocation.width,
		window1->allocation.height);

	gdk_gc_set_clip_mask( window1->style->bg_gc[GTK_WIDGET_STATE(window1)], NULL );
}
/*
 * Cartridge Pixmap Draw 
 */
void cartridge_pixmap_draw( 	GtkWidget *window1 )
{
	int	i;

	if( chd_kind == 0 )	return;

	for( i=0; i<CHD_AREA_MAX; i++){
		if( pat_tbl[chd_kind-1][i].pat_no == 0 ) break;

		gdk_gc_set_clip_mask( window1->style->bg_gc[GTK_WIDGET_STATE(window1)], 
						*mask_p[(pat_tbl[chd_kind-1][i].pat_no)-1] );

		gdk_gc_set_clip_origin( window1->style->bg_gc[GTK_WIDGET_STATE(window1)], 
			dw+(pat_tbl[chd_kind-1][i].p_x) ,dh+CHD_Y_OFF );

		gdk_draw_pixmap( pixmap ,window1->style->bg_gc[GTK_WIDGET_STATE(window1)],
			*ink_p[(pat_tbl[chd_kind-1][i].pat_no)-1],
			0,0,
			dw+(pat_tbl[chd_kind-1][i].p_x) ,dh+CHD_Y_OFF,
			window1->allocation.width,
			window1->allocation.height);

		gdk_gc_set_clip_mask( window1->style->bg_gc[GTK_WIDGET_STATE(window1)], NULL);

//		if( pat_tbl[chd_kind-1][i+1].pat_no == 0 ) break;
	}
}
/*
 * Cartridge Area Clear
 */
void cartridge_pixmap_clear( GtkWidget *window1 )
{
	gdk_draw_rectangle( pixmap,window1->style->bg_gc[GTK_WIDGET_STATE(window1)],
			TRUE,0,0,
			window1->allocation.width,
			window1->allocation.height);
}

/* 
 * Socket Send to LM
 */
void socket_send_LM( 	int	cmd )
{
	int	ret;

	lmsm_s.socket_type = SMtoLM;	
	lmsm_s.command     = cmd;
	ret = write( sock_path, &lmsm_s, sizeof(lmsm_s));
}
